> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/compute/bmc/load-balancing/createlistener.md).

# CreateListener

## 1. API Description

This API (CreateListener) is used to create TCP, UDP, or TCPSSL listeners in a load balancer.

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name  | Required | Type                                                                   | Description                                                                                                                                                                                                                                                                              |
| --------------- | -------- | ---------------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| loadBalancerId  | Yes      | String                                                                 | Load balance instance ID.                                                                                                                                                                                                                                                                |
| listenerName    | Yes      | String                                                                 | <p>Listener name.</p><p>This parameter can contain up to 64 characters. Only letters, numbers, - and periods (.) are supported.</p>                                                                                                                                                      |
| portList        | Yes      | Array of Integer                                                       | <p>Listening ports.</p><p>Value range: 0\~65535 .</p><p>Example value: \[" 6569 "]</p>                                                                                                                                                                                                   |
| clientToken     | Yes      | String                                                                 | Used to ensure the idempotency of the request.                                                                                                                                                                                                                                           |
| protocol        | Yes      | String                                                                 | <p>Listening protocols.</p><p>Available values:</p><p>TCP UDP</p>                                                                                                                                                                                                                        |
| backendProtocol | Yes      | String                                                                 | <p>Backend forwarding protocol.</p><p>Available values:</p><p>TCP UDP</p>                                                                                                                                                                                                                |
| scheduler       | No       | String                                                                 | <p>Scheduling algorithm.</p><p>Available values:</p><p>wrr (default): Weighted round robin, the higher the weight value of the backend server, the higher the probability of being polled. rr : Round robin, distribute external requests to backend servers in the order of access.</p> |
| kind            | No       | [LbKind](/api-reference/compute/bmc/datastructure.md#lbkind)           | <p>Forwarding modes.</p><p>Available values:</p><p>FNAT (Global Network Address Translation) DR (Direct Routing)</p><p>Default value: DR</p>                                                                                                                                             |
| healthCheck     | No       | [HealthCheck](/api-reference/compute/bmc/datastructure.md#healthcheck) | Information on the health check.                                                                                                                                                                                                                                                         |
| notify          | No       | [Notify](/api-reference/compute/bmc/datastructure.md#notify)           | Alarm.                                                                                                                                                                                                                                                                                   |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| listenerId     | String | The listener ID.                                                                                                      |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Create a listener.**

```json
POST /api/v2/bmc HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: CreateListener
<Common Request Params>

Request:
{
  "loadBalancerId": "xxxx",
  "name": "xxxx",
  "portList": [80],
  "clientToken": "xxxx",
  "protocol": "TCP",
  "backendProtocol": "TCP"
}

Response:
{
  "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
  "response": {
    "requestId": "TEEFDCA5B-76FB-4E91-A18E-DF7F5D2CE41F",
    "listenerId": "xxxx"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
